# pyloc3d

Python bindings for Sarah's `AHloc3d` (actually depends on this fork here: https://git.tpi.uni-jena.de/fatteneder/ahloc3d).

# Instructions


- Install the `cffi` package, e.g.
```sh
pip install --user cffi
```
- Clone the repo https://git.tpi.uni-jena.de/fatteneder/ahloc3d
- Compile `AHloc3d` into a shared library (I think only dependency is `MPI` which is not used
  by `pyloc3d` but still needs to be installed)
```sh
cd ahloc3d
make lib
```
- Generate the glue code for python. This might require you to update the arguments
of the function call `ffibuilder.set_source` inside `wrap_ahloc3d.py` to conform with
your installation. In particular for `mpi` you will have to specify the right
`include_dirs` which you should be able to query from a command line using
```sh
pkg-config --cflags mpi
```
Then run to following to wrap it:
```sh
cd pyloc3d
./wrap_ahloc3d
```
- You need to set `LD_LIBRARY_PATH` so that python can find `libAHloc3d`
```
export LD_LIBRARY_PATH="<absolute-path-to-ahloc3d-git-folder>"
```
- Test it
```sh
./pyloc3d
```


# Hack notes

- If `AHloc3d` changes one needs to rerun the instructions above.
