#!/usr/bin/env python3


import os
from cffi import FFI
ffibuilder = FFI()

path_ahloc_header = os.path.abspath(os.path.join('..', 'ahloc3d', 'src', 'AHloc.h'))
with open(path_ahloc_header, 'r') as file:
        header = file.readlines()

# need to filter all # directives (like #include, #define etc.) because they are not
# supported by cffi
header = list(filter(lambda line: not line.startswith('#'), header))
header = ''.join(header)

ffibuilder.cdef(header)
ffibuilder.set_source("_ahloc_3d", f"""#include "{path_ahloc_header}" """,
                      libraries=['AHloc','mpi'],
                      library_dirs=['../ahloc3d/', '../ahloc3d/src', '../ahloc3d/objs'],
                      include_dirs=['/usr/lib/x86_64-linux-gnu/openmpi/include',
                                    '/usr/lib/x86_64-linux-gnu/openmpi/include/openmpi'])

if __name__ == "__main__":
        ffibuilder.compile(verbose=True)
